
Infrastructure - Task #3365

Story # 3309 (Closed): get() downloads have inconsistent mime types and filenames

create Java ObjectFormatInfo class to provide mime lookup

2012-10-25 08:26 - Matthew Jones

Status: Closed Start date: 2012-10-25

Priority: High Due date:  

Assignee: Matthew Jones % Done: 100%

Category: d1_libclient_java Estimated time: 0.00 hour

Target version: CCI-2.0.0   

Milestone: CCI-1.1 Story Points:  

Product Version: *   

Description

We will use utility classes in libclient to provide a consistent lookup service to allow applications to find out the mime type and file

extension for formatIDs.  Create an ObjectFormatInfo class that provides:

* a static singleton that can be called from anywhere in an application

* function to find the mime type based on a formt identifier string

* function to find the mime type based on an ObjectFormat instance

* function to find the extension based on a formt identifier string

* function to find the extension based on an ObjectFormat instance

* a default set of mapping data that ships with libclient as a CSV file

* the ability for calling applications to set a property (D1Client.resourcesDir) that determines where this CSV data file will live on disk

* the ObjectFormatInfo class should be able to reload itself at runtime, re-reading the CSV file so applications can refresh mappings

without a restart

History

#1 - 2012-10-25 08:30 - Matthew Jones

- Status changed from In Progress to Testing

Implemented the ObjectFormatInfo class and associated CSV file.  Created JUnit test to run some simple sanity checks on operation.  After testing

and review, this task can be closed if no new issues are identified.

#2 - 2012-10-25 08:35 - Matthew Jones

Usage of the class uses calls such as:

@

String mimetype = ObjectFormatInfo.instance().getMimeType("netCDF-3");

String extension = ObjectFormatInfo.instance().getExtension("netCDF-3");

@

#3 - 2012-10-26 16:19 - Ben Leinfelder

Now using in Metacat trunk -- initial testing looks good.

#4 - 2012-10-26 17:23 - Ben Leinfelder

Changes to local file were reflected in download.

Moving mapping file to new location and point configuration to that location worked, too.

I'm happy with this feature.
#5 - 2012-10-29 17:04 - Matthew Jones

- translation missing: en.field_remaining_hours set to 0.0

- % Done changed from 90 to 100

- Status changed from Testing to Closed

Tetsing successful with Metacat, so closing.

#6 - 2012-12-12 18:33 - Chris Jones

- Target version changed from Sprint-2012.44-Block.6.2 to 2013.2-Block.1.1

#7 - 2013-03-01 19:09 - Chris Jones

- Target version changed from 2013.2-Block.1.1 to 2013.12-Block.2.2

#8 - 2013-08-02 17:20 - Dave Vieglais

- Target version changed from 2013.12-Block.2.2 to 2013.35-Block.5.1

#9 - 2014-01-06 18:04 - Chris Jones

- Target version changed from 2013.35-Block.5.1 to 2014.6-Block.1.3

#10 - 2014-03-14 18:47 - Roger Dahl

- Target version changed from 2014.6-Block.1.3 to 2014.14-Block.2.3

#11 - 2014-09-24 18:28 - Dave Vieglais

- Target version changed from 2014.14-Block.2.3 to CCI-1.4.2

#12 - 2014-09-25 16:47 - Dave Vieglais

- Target version changed from CCI-1.4.2 to CCI-1.5.0

#13 - 2014-10-02 19:41 - Dave Vieglais

- Target version changed from CCI-1.5.0 to CCI-2.0.0
